# -*- coding: utf-8 -*-
"""
Created on Mon Aug 17 19:16:19 2015

@author: Sven
"""

import numpy as np

def montecarlo(linksunten, rechtsoben, n, func):
    '''Sucht Ackley-Funktion nach Minimum ab mittels Monte-Carlo-Verfahren'''
    # Variablen für aktuelles Minimum
    min_y = 0
    min_x = 0
    min_z = 0
    # Suchgebiet
    xu = linksunten[0]
    yu = linksunten[1]
    xo = rechtsoben[0]
    yo = rechtsoben[1]
    d_x = xo-xu
    d_y = yo-yu
    # Zufälligen xy-Koordinate im Suchgebiet erzeugen
    point = [xu + d_x*np.random.rand(), yu + d_y*np.random.rand()]
    min_x,min_y = np.meshgrid([point[0]],[point[1]])
  
    # z-Koordinate berechnen
    min_z = func(min_x,min_y)[0][0]
    
    for i in range(n-1):
        point = [xu + d_x*np.random.rand(), yu + d_y*np.random.rand()]
        px,py = np.meshgrid([point[0]],[point[1]])
        pz = func(px,py)[0][0]
        # Testen ob ein neues Minimum gefunden wurde
        if pz < min_z:
            min_z = pz
            min_x = px
            min_y = py
    
    return min_x[0][0],min_y[0][0],min_z
    

def ackley(x, y):
    '''Ackley'''
    a = -20 * np.exp(-0.2*np.sqrt((x**2 + y**2)/2))
    b = -np.exp((np.cos(2*np.pi*x) + np.cos(2*np.pi*y))/2)
    z = a + b + 20 + np.exp(1)
    return z